Implementation of multi-threaded rsync for base backups
04/17/2014 09:08 AM - Joshua A. Drake

Status: Resolved Start date: 04/17/2014
Priority: Normal Due date:

Assignee: % Done: 0%
Category: Estimated time: 0.00 hour
Target version:

Resolution:

Description

Due to the single-threaded nature of pg_basebackup, performing a base backup can be a rather slow process.
Multi-threading the interface in Python would resolve this.

History

#1 - 04/17/2014 09:11 AM - Joshua Drake
- File threaded_rsync.py added

On 04/17/2014 09:08 AM, pitrtools-tickets@lists.commandprompt.com wrote:

Due to the single-threaded nature of pg_basebackup, performing a base backup can be a rather slow process.
Multi-threading the interface in Python would resolve this.

Here is the code to implement.
{{attachment(204)}}
#2 - 04/17/2014 09:28 AM - Joshua A. Drake
Development plan:

e Add value rsync_threads (int) to cmd_standby.ini; Default 1
- Corresponds to --num_threads options passed to threaded_rsync.py. Defines amount of threads used in parallel rsync for base backups.

e Update doc/cmd_standby.README accordingly
¢ In cmd_standby: CMDStandby.base_backup_func, insert threaded_rsync.py with appropriate options

#3 - 04/17/2014 10:21 AM - Joshua A. Drake

https://github.com/commandprompt/PITRTools/pull/37

#4 - 04/17/2014 10:33 AM - Joshua A. Drake

- Status changed from New to Resolved

#5 - 05/07/2014 10:35 AM - Joshua A. Drake

threaded_rsync.py is not always located correctly as it is referred to by a relative path
Fix: https://github.com/commandprompt/PITRTools/pull/41

#6 - 05/15/2014 12:08 PM - Joshua A. Drake

threaded_rsync.py is not invoked "properly" in subprocess.call(), and thus only works sometimes.
Fix: https://github.com/commandprompt/PITRTools/pull/43
